package com.huimv.farm.damsubsidy.common.utils;

import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.huimv.farm.damsubsidy.entity.PovertyUserRegist;
import org.apache.poi.ss.formula.functions.T;

import java.math.BigInteger;
import java.security.MessageDigest;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

public class PovertyUtils {

    public static List<PovertyUserRegist> getPoverty(List<Map<String, Object>> read,Long userId) {
        Date date = new Date();
        List<PovertyUserRegist> endList = new ArrayList<>();
        for (Map<String, Object> stringObjectMap : read) {
            PovertyUserRegist povertyUserRegist = new PovertyUserRegist();
            povertyUserRegist.setXh(stringObjectMap.get("序号")+"");
            povertyUserRegist.setCounty(stringObjectMap.get("县(市、区、旗)")+"");
            povertyUserRegist.setVillage(stringObjectMap.get("乡(镇)")+"");
            povertyUserRegist.setXzc(stringObjectMap.get("行政村")+"");
            povertyUserRegist.setZrc(stringObjectMap.get("自然村")+"");
            povertyUserRegist.setFpzph(stringObjectMap.get("易返贫致贫户(监测对象)类别")+"");
            povertyUserRegist.setHbh(stringObjectMap.get("户编号")+"");
            povertyUserRegist.setRbh(stringObjectMap.get("人编号")+"");
            povertyUserRegist.setXm(stringObjectMap.get("姓名")+"");
            povertyUserRegist.setZjhm(stringObjectMap.get("证件号码")+"");
            povertyUserRegist.setJtrks(stringObjectMap.get("家庭人口数")+"");
            povertyUserRegist.setYhzgx(stringObjectMap.get("与户主关系")+"");
            povertyUserRegist.setMz(stringObjectMap.get("民族")+"");
            povertyUserRegist.setZzmm(stringObjectMap.get("政治面貌")+"");
            povertyUserRegist.setWhcd(stringObjectMap.get("文化程度")+"");
            povertyUserRegist.setZxszk(stringObjectMap.get("在校生状况")+"");
            povertyUserRegist.setJkzk(stringObjectMap.get("健康状况")+"");
            povertyUserRegist.setLdjn(stringObjectMap.get("劳动技能")+"");
            povertyUserRegist.setSfCxJmJbYl(stringObjectMap.get("是否参加城乡居民基本医疗保险")+"");
            povertyUserRegist.setSfCzZgJbYl(stringObjectMap.get("是否参加城镇职工基本医疗保险")+"");
            povertyUserRegist.setSfCxJmJbLao(stringObjectMap.get("是否参加城乡居民基本养老保险")+"");
            povertyUserRegist.setSfCzZgJbLao(stringObjectMap.get("是否参加城镇职工基本养老保险")+"");
            povertyUserRegist.setSfShbz(stringObjectMap.get("是否享受农村居民最低生活保障")+"");
            povertyUserRegist.setSfDbbx(stringObjectMap.get("是否参加大病保险")+"");
            povertyUserRegist.setSfTkgy(stringObjectMap.get("是否特困供养人员")+"");
            povertyUserRegist.setSfYifpbq(stringObjectMap.get("是否易地扶贫搬迁人口")+"");
            povertyUserRegist.setWgqy(stringObjectMap.get("务工区域")+"");
            povertyUserRegist.setWgsj(stringObjectMap.get("务工时间")+"");
            povertyUserRegist.setLxdh(stringObjectMap.get("联系电话")+"");
            povertyUserRegist.setSfJzDzAn(stringObjectMap.get("是否居住在大中型异地扶贫搬迁集中安置区")+"");
            povertyUserRegist.setAndz(stringObjectMap.get("安置区地址")+"");
            povertyUserRegist.setXmmc(stringObjectMap.get("项目名称")+"");
            povertyUserRegist.setSfFx(stringObjectMap.get("风险是否已消除")+"");
            povertyUserRegist.setFxbzcx(stringObjectMap.get("风险标注次序")+"");
            povertyUserRegist.setFxsbsj(stringObjectMap.get("风险识别时间")+"");
            povertyUserRegist.setFxxcsj(stringObjectMap.get("风险消除时间")+"");
            povertyUserRegist.setFxxcfs(stringObjectMap.get("风险消除方式")+"");
            povertyUserRegist.setZpfx1(stringObjectMap.get("致贫风险1")+"");
            povertyUserRegist.setZpfx2(stringObjectMap.get("致贫风险2")+"");
            povertyUserRegist.setZpfx3(stringObjectMap.get("致贫风险3")+"");
            povertyUserRegist.setZpfx4(stringObjectMap.get("致贫风险4")+"");
            povertyUserRegist.setZpfx5(stringObjectMap.get("致贫风险5")+"");
            povertyUserRegist.setBz(stringObjectMap.get("备注")+"");
            povertyUserRegist.setZrzhlx(stringObjectMap.get("自然灾害类型")+"");
            povertyUserRegist.setXxcjr(stringObjectMap.get("信息采集人")+"");
//            povertyUserRegist.setXxcjLxdh(stringObjectMap.get("联系电话")+"");
            povertyUserRegist.setSfFxbzZfaq(stringObjectMap.get("风险标注信息是否住房出现安全问题")+"");
            povertyUserRegist.setSfFxbzYwjy(stringObjectMap.get("风险标注信息是否义务教育阶段适龄儿童少年失学辍学")+"");
            povertyUserRegist.setSfFxbzYsaq(stringObjectMap.get("风险标注信息是否饮水出现安全问题")+"");
            povertyUserRegist.setSfFxbzWcjcx(stringObjectMap.get("风险标注信息是否有家庭成员未参加城乡居民（职工）基本医疗保险")+"");
            povertyUserRegist.setSfFxxcZfaq(stringObjectMap.get("风险消除信息是否住房出现安全问题")+"");
            povertyUserRegist.setSfFxxcYwjy(stringObjectMap.get("风险消除信息是否义务教育阶段适龄儿童少年失学辍学")+"");
            povertyUserRegist.setSfFxxcYsaq(stringObjectMap.get("风险消除信息是否饮水出现安全问题")+"");
            povertyUserRegist.setSfFxxcWcjcx(stringObjectMap.get("风险消除信息是否有家庭成员未参加城乡居民（职工）基本医疗保险")+"");
            povertyUserRegist.setFxbzSrGz(stringObjectMap.get("风险标注信息工资性收入")+"");
            povertyUserRegist.setFxbzSrSc(stringObjectMap.get("风险标注信息生产经营性收入")+"");
            povertyUserRegist.setFxbzSrCc(stringObjectMap.get("风险标注信息财产性收入")+"");
            povertyUserRegist.setFxbzSrZy(stringObjectMap.get("风险标注信息转移性收入")+"");
            povertyUserRegist.setFxbzZcScjy(stringObjectMap.get("风险标注信息生产经营性支出")+"");
            povertyUserRegist.setFxbzSrC(stringObjectMap.get("风险标注信息家庭纯收入")+"");
            povertyUserRegist.setFxbzSrRjc(stringObjectMap.get("风险标注信息家庭人均纯收入")+"");
            povertyUserRegist.setFxbzSrLp(stringObjectMap.get("风险标注信息理赔收入")+"");
            povertyUserRegist.setFxbzZcXxhg(stringObjectMap.get("风险标注信息合规自付支出")+"");
            povertyUserRegist.setFxbzNrFw(stringObjectMap.get("风险标注信息纳入易返贫致贫户(监测对象)的收入参考范围")+"");
            povertyUserRegist.setFxbzNrRjfw(stringObjectMap.get("风险标注信息纳入易返贫致贫户(监测对象)的人均收入参考范围")+"");
            povertyUserRegist.setFxxcSrGz(stringObjectMap.get("风险消除信息工资性收入")+"");
            povertyUserRegist.setFxxcSrSc(stringObjectMap.get("风险消除信息生产经营性收入")+"");
            povertyUserRegist.setFxxcSrCc(stringObjectMap.get("风险消除信息财产性收入")+"");
            povertyUserRegist.setFxxcSrZy(stringObjectMap.get("风险消除信息转移性收入")+"");
            povertyUserRegist.setFxxcZcScjy(stringObjectMap.get("风险消除信息生产经营性支出")+"");
            povertyUserRegist.setFxxcSrC(stringObjectMap.get("风险消除信息家庭纯收入")+"");
            povertyUserRegist.setFxxcSrRjc(stringObjectMap.get("风险消除信息家庭人均纯收入")+"");
            povertyUserRegist.setFxxcSrLp(stringObjectMap.get("风险消除信息理赔收入")+"");
            povertyUserRegist.setFxxcZcXxhg(stringObjectMap.get("风险消除信息合规自付支出")+"");
            povertyUserRegist.setFxxcNrFw(stringObjectMap.get("风险消除信息纳入易返贫致贫户(监测对象)的收入参考范围")+"");
            povertyUserRegist.setFxxcNrRjfw(stringObjectMap.get("风险消除信息纳入易返贫致贫户(监测对象)的人均收入参考范围")+"");
            povertyUserRegist.setCybf(stringObjectMap.get("产业帮扶")+"");
            povertyUserRegist.setJybf(stringObjectMap.get("就业帮扶")+"");
            povertyUserRegist.setJrbf(stringObjectMap.get("金融帮扶")+"");
            povertyUserRegist.setGygbf(stringObjectMap.get("公益岗位帮扶")+"");
            povertyUserRegist.setZfaqbz(stringObjectMap.get("住房安全保障")+"");
            povertyUserRegist.setYsaqbz(stringObjectMap.get("饮水安全保障")+"");
            povertyUserRegist.setJkbf(stringObjectMap.get("健康帮扶")+"");
            povertyUserRegist.setYwjybz(stringObjectMap.get("义务教育保障")+"");
            povertyUserRegist.setJybf(stringObjectMap.get("教育帮扶")+"");
            povertyUserRegist.setZhbz(stringObjectMap.get("综合保障")+"");
            povertyUserRegist.setShbf(stringObjectMap.get("社会帮扶")+"");
            povertyUserRegist.setBq(stringObjectMap.get("搬迁")+"");
            povertyUserRegist.setScshtjgz(stringObjectMap.get("生产生活条件改善")+"");
            povertyUserRegist.setJcssjs(stringObjectMap.get("基础设施建设")+"");
            //
            povertyUserRegist.setUpdateTime(date);
            povertyUserRegist.setUpdateUser(userId);
            povertyUserRegist.setCreatTime(date);
            povertyUserRegist.setCreatUser(userId);
            endList.add(povertyUserRegist);
        }
        return  endList;
    }

    public static List getEartagNo(String eartags){
        if (StringUtils.isBlank(eartags)){
            return null;
        }
        eartags = eartags.replace("，",",").replace(" ","");
        String[] split = eartags.split(",");
        List list = new ArrayList();
        for (String input : split) {
            if (input.contains("-")) {
                String start = input.substring(0, input.indexOf("-"));
                String end = input.substring(input.indexOf("-") + 1);
                String substring1 = input.substring(start.length() - end.length(), start.length());
                int starNo = Integer.parseInt(substring1);
                int endNo = Integer.parseInt(end);
                if (Integer.parseInt(substring1) >Integer.parseInt(end) ){
                    return null;
                }
                for (int i = starNo ;i<=endNo;i++) {
                    list.add(start+i);
                }
            }else {
                list.add(input);
            }
        }
        return list;
    }
}
