package com.huimv.farm.damsubsidy.controller;

import com.huimv.farm.damsubsidy.common.utils.Result;
import com.huimv.farm.damsubsidy.common.utils.ResultCode;
import com.huimv.farm.damsubsidy.entity.BaseVeterStation;
import com.huimv.farm.damsubsidy.service.IBaseVeterStationService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2023-05-05
 */
@CrossOrigin
@RestController
@RequestMapping("/base-veter-station")
public class BaseVeterStationController {

    @Autowired
    private IBaseVeterStationService baseVeterStationService;

    @PostMapping("/add")
    public Result addMenu(@RequestBody BaseVeterStation baseVeterStation , HttpServletRequest request){
        baseVeterStationService.save(baseVeterStation);
        return new Result(ResultCode.SUCCESS,"添加成功");
    }

    @PostMapping("/edit")
    public Result editMenu(@RequestBody BaseVeterStation baseVeterStation){
        baseVeterStationService.updateById(baseVeterStation);
        return new Result(ResultCode.SUCCESS,"修改成功");
    }

    @RequestMapping("/remove")
    public Result removeMenu(@RequestParam(name = "id") Integer id){
        baseVeterStationService.removeById(id);
        return new Result(ResultCode.SUCCESS,"删除成功");
    }

    @PostMapping("/list")
    public Result list() {
        return new Result(ResultCode.SUCCESS,baseVeterStationService.list());
    }


    @PostMapping("/page")
    public Result page( @RequestBody Map map) {
        return baseVeterStationService.page(map);
    }
}
