package com.huimv.farm.damsubsidy.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.farm.damsubsidy.common.utils.Result;
import com.huimv.farm.damsubsidy.common.utils.ResultCode;
import com.huimv.farm.damsubsidy.entity.BillBuyInfo;
import com.huimv.farm.damsubsidy.service.IBillBuyInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import java.io.IOException;
import java.util.Map;

/**
 * <p>
 * 交易信息 前端控制器
 * </p>
 *
 * @author author
 * @since 2023-04-26
 */
@RestController
@RequestMapping("/bill-buy-info")
@CrossOrigin
public class BillBuyInfoController {
    @Autowired
    private IBillBuyInfoService billBuyInfoService;

    @PostMapping("/listTransaction")
    public Result listTransaction(@RequestBody Map<String,String> paramsMap){
        String pageNum = paramsMap.get("pageNum");
        String pageSize = paramsMap.get("pageSize");
        Page<BillBuyInfo> page = new Page(Integer.parseInt(pageNum),Integer.parseInt(pageSize));
        return new Result(ResultCode.SUCCESS,billBuyInfoService.page(page,new QueryWrapper<BillBuyInfo>().orderByDesc("create_time").eq("bill_buy_status",2)));
    }

    @PostMapping("/addTransaction")
    public Result addTransaction(HttpServletRequest httpServletRequest,
                                 @RequestParam("image1") MultipartFile image1,
                                 @RequestParam("image2") MultipartFile image2,
                                 @RequestParam("image3") MultipartFile image3,
                                 @RequestParam("inspectionNum") String inspectionNum,
                                 @RequestParam("seller") String seller,
                                 @RequestParam("buyer") String buyer,
                                 @RequestParam("num") String num,
                                 @RequestParam("eartags") String eartags,
                                 @RequestParam("buyerPhone")String buyerPhone) throws IOException {
        return billBuyInfoService.addTransaction(httpServletRequest,image1,image2,image3,inspectionNum,seller,buyer,num,eartags,buyerPhone);
    }

    @PostMapping("/saveTransaction")
    public Result saveTransaction(HttpServletRequest httpServletRequest,@RequestBody Map<String,String> paramsMap){
        return billBuyInfoService.saveTransaction(httpServletRequest,paramsMap);
    }

    @PostMapping("/getLast")
    public Result getLast(HttpServletRequest httpServletRequest,@RequestBody Map<String,String> paramsMap){
        return billBuyInfoService.getLast(httpServletRequest,paramsMap);
    }

    @PostMapping("/listDetail")
    public Result listDetail(HttpServletRequest httpServletRequest,@RequestBody Map<String,String> paramsMap){
        return billBuyInfoService.listDetail(httpServletRequest,paramsMap);
    }



}
