package com.huimv.farm.damsubsidy.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.farm.damsubsidy.common.utils.Result;
import com.huimv.farm.damsubsidy.common.utils.ResultCode;
import com.huimv.farm.damsubsidy.entity.BillIsolated;
import com.huimv.farm.damsubsidy.service.IBillIsolatedService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import java.text.ParseException;
import java.util.Map;

/**
 * <p>
 * 落地检 前端控制器
 * </p>
 *
 * @author author
 * @since 2023-04-26
 */
@RestController
@RequestMapping("/bill-isolated")
@CrossOrigin
public class BillIsolatedController {

    @Autowired
    private IBillIsolatedService iBillIsolatedService;

    @PostMapping("/addIsolation")
    public Result  addIsolation(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) throws ParseException {
        return iBillIsolatedService.addIsolation(httpServletRequest,paramsMap);
    }

    @PostMapping("/listIsolation")
    public Result listIsolation(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap){
        return iBillIsolatedService.listIsolation(httpServletRequest,paramsMap);
    }

    @PostMapping("/delayedIsolation")
    public Result delayedIsolation(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap){
        return iBillIsolatedService.delayedIsolation(httpServletRequest,paramsMap);
    }

    @PostMapping("/cancelIsolation")
    public Result cancelIsolation(HttpServletRequest httpServletRequest,
                                  @RequestParam("image") MultipartFile image,
                                  @RequestParam("id") String id,
                                  @RequestParam("isDead") String isDead,
                                  @RequestParam("deaths") String deaths){
        return iBillIsolatedService.cancelIsolation(httpServletRequest,image,id,isDead,deaths);
    }

    @PostMapping("/listDetail")
    public Result listDetail(@RequestBody Map<String, String> paramsMap){
        String inspectionNum = paramsMap.get("inspectionNum");
        // TODO
        return new Result(ResultCode.SUCCESS,iBillIsolatedService.getOne(new QueryWrapper<BillIsolated>().eq("inspection_num",inspectionNum)));
    }
}
