package com.huimv.farm.damsubsidy.controller;


import cn.hutool.http.HttpRequest;
import cn.hutool.poi.excel.ExcelReader;
import cn.hutool.poi.excel.ExcelUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.huimv.farm.damsubsidy.common.token.TokenSign;
import com.huimv.farm.damsubsidy.common.utils.PovertyUtils;
import com.huimv.farm.damsubsidy.common.utils.Result;
import com.huimv.farm.damsubsidy.common.utils.ResultCode;
import com.huimv.farm.damsubsidy.entity.BaseVeterStation;
import com.huimv.farm.damsubsidy.entity.PovertyUserRegist;
import com.huimv.farm.damsubsidy.entity.SysUser;
import com.huimv.farm.damsubsidy.service.IPovertyUserRegistService;
import com.huimv.farm.damsubsidy.service.ISysUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 隔离日志 前端控制器
 * </p>
 *
 * @author author
 * @since 2023-04-28
 */
@CrossOrigin
@RestController
@RequestMapping("/poverty-user-regist")
public class PovertyUserRegistController {
    @Autowired
    private IPovertyUserRegistService povertyUserRegistService;
    @Autowired
    private ISysUserService sysUserService;

    @RequestMapping("excelPovert/import")
    @ResponseBody
    @Transactional
    public Result userId(@RequestParam(value = "file", required = true) MultipartFile file, HttpServletRequest request) throws Exception {
        PovertyUserRegist povertyUserRegist = new PovertyUserRegist();
        Long userId = TokenSign.getMemberIdByJwtToken(request);
        povertyUserRegist.setIsDelete(1);
        povertyUserRegist.setUpdateTime(new Date());
        povertyUserRegist.setUpdateUser(userId);
        UpdateWrapper<PovertyUserRegist> updateWrapper = new UpdateWrapper<>();
        povertyUserRegistService.update(povertyUserRegist,updateWrapper.eq("is_delete",0));

        //导入贫困户，1 删除之前的，
        ExcelReader reader = ExcelUtil.getReader(file.getInputStream());
        List<Map<String, Object>> read = reader.read(2, 3, 2147483647);
        List<PovertyUserRegist> poverty = PovertyUtils.getPoverty(read,userId);
        povertyUserRegistService.saveBatch(poverty);

        //实名养殖户
        QueryWrapper<SysUser> sysUserQueryWrapper = new QueryWrapper<>();
        sysUserQueryWrapper.eq("is_real_name",1).eq("user_type",3).eq("is_delete",0);
        List<SysUser> list = sysUserService.list(sysUserQueryWrapper);
        //1查询未删除的 2，查询已经删除的
        for (SysUser sysUser : list) {
//            String userName = sysUser.getUserName();
            String idCard = sysUser.getIdCard();
            QueryWrapper<PovertyUserRegist> wrapper = new QueryWrapper<>();
            wrapper.eq("ZJHM",idCard);
            wrapper.eq("is_delete",0);
            int count = povertyUserRegistService.count(wrapper);
            if (count >0 ){
                sysUser.setFarmType(0);
                sysUserService.updateById(sysUser);
                break;
            }
            wrapper.clear();
            wrapper.eq("ZJHM",idCard);
            wrapper.eq("is_delete",1);
            int countDelete = povertyUserRegistService.count(wrapper);
            if (countDelete > 0 ){
                sysUser.setFarmType(1);
                sysUserService.updateById(sysUser);
                break;
            }
            sysUser.setFarmType(2);
            sysUserService.updateById(sysUser);
        }
        return new Result(ResultCode.SUCCESS,"上传成功");
    }

    @PostMapping("excelPovert/list")
    public Result list(@RequestBody Map map, HttpServletRequest request) throws Exception {
      return povertyUserRegistService.list(map,request);
    }

}
