package com.huimv.farm.damsubsidy.controller;


import com.huimv.farm.damsubsidy.entity.Sheet1;
import com.huimv.farm.damsubsidy.mapper.Sheet1Mapper;
import com.huimv.farm.damsubsidy.service.ISheet1Service;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2023-05-06
 */
@CrossOrigin
@RestController
@RequestMapping("/sheet1")
public class Sheet1Controller {
    @Autowired
    private ISheet1Service sheet1Service;
    @GetMapping("/sheet")
    public Map<String, Map<String, Map<String, List<Sheet1>>>> getAll() {

        //每个province的map都放进去
        Map<String, Map<String, Map<String, List<Sheet1>>>> provinceMap = new HashMap<>();

        //获取所有的数据
        List<Sheet1> all = sheet1Service.list();

        //根据pro_code分好的List 相当于每个province
        Map<String, List<Sheet1>> provinces = all.stream().collect(Collectors.groupingBy(Sheet1::getCodeProv));

        for (Map.Entry<String,List<Sheet1>> province : provinces.entrySet()) {
            //获取每个省的cityList
            List<Sheet1> singleProvince = province.getValue();

            //每个city的countryList
            Map<String, List<Sheet1>> cities = singleProvince.stream().collect(Collectors.groupingBy(Sheet1::getCodeCity));

            //每个city的map都放进去
            Map<String, Map<String, List<Sheet1>>> cityMap = new HashMap<>();

            for (Map.Entry<String,List<Sheet1>> city : cities.entrySet()) {

                //每个city的countryList
                List<Sheet1> singleCity = city.getValue();

                //根据country的code区分的list 也就是每个country的townList
                Map<String, List<Sheet1>> countrys = singleCity.stream().collect(Collectors.groupingBy(Sheet1::getCodeCoun));

                cityMap.put(city.getKey(), countrys);
            }

            provinceMap.put(province.getKey(), cityMap);
        }
        return provinceMap;
    }

}
