package com.huimv.farm.damsubsidy.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import java.io.Serializable;
import java.util.Date;

import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 动物信息
 * </p>
 *
 * @author author
 * @since 2023-04-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("base_animal")
public class BaseAnimal extends BaseEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 耳标号
     */
    private String earatgNo;

    /**
     * 所属人
     */
    private Long belongToUser;

    /**
     * 0肉牛，1羊，2猪
     */
    private Integer animalType;

    /**
     * 0隔离中，1隔离结束，2已交易，3补贴完成
     */
    private Integer animalStatus;

    /**
     * 检疫证号
     */
    private String inspectionNum;

    /**
     * 买方id
     */
    private Long buyerId;

    /**
     * 卖方id
     */
    private Long sellerId;

    /**
     * 买方名称
     */
    private String buyerName;

    /**
     * 卖方名字
     */
    private String sellerName;

    /**
     * 是否申请补贴:0未申请，1已申请
     */
    private Integer isLoated;

    /**
     * 购买时间
     */
    private Date buyTime;

    /**
     * 0正常 1,死亡
     */
    private Integer isDie;



}
