package com.huimv.farm.damsubsidy.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import java.util.Date;
import java.io.Serializable;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 交易信息
 * </p>
 *
 * @author author
 * @since 2023-04-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("bill_buy_info")
public class BillBuyInfo  extends BaseEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.ASSIGN_ID)
    private Long id;

    private String buyName;

    /**
     * 检疫证号
     */
    private String inspectionNum;

    /**
     * 买方名字
     */
    private String buyerName;

    /**
     * 卖方名字
     */
    private String sellerName;

    /**
     * 数量及单位
     */
    private String realNumUp;

    /**
     * 实际数量
     */
    private Integer realNum;

    /**
     * 实际耳标号
     */
    private String realEartag;

    /**
     * 购买协议图片url
     */
    private String buyPicUrl;

    /**
     * 支付信息图片url
     */
    private String payPicUrl;

    /**
     * 购买合照图片url
     */
    private String buyPayGoodsPicUrl;

    /**
     * 0未完成，1草稿，2已完成
     */
    private Integer billBuyStatus;

    private String buyerPhone;

    private Long buyerId;

    private Long sellerId;



}
