package com.huimv.farm.damsubsidy.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import java.io.Serializable;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.huimv.farm.damsubsidy.common.annotate.DictTranslate;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 隔离日志
 * </p>
 *
 * @author author
 * @since 2023-04-28
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("poverty_user_regist")
public class PovertyUserRegist implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss" ,timezone = "GMT+8")
    private Date creatTime;

    private Long creatUser;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss" ,timezone = "GMT+8")
    private Date updateTime;

    private Long updateUser;

    private Integer isDelete;

    /**
     * 序号
     */
    private String xh;

    /**
     * 县(市、区、旗)
     */
    private String county;

    /**
     * 乡(镇)
     */
    private String village;

    /**
     * 行政村
     */
    private String xzc;

    /**
     * 自然村
     */
    private String zrc;

    /**
     * 易返贫致贫户(监测对象)类别
     */
    private String fpzph;

    /**
     * 户编号
     */
    private String hbh;

    /**
     * 人编号
     */
    private String rbh;

    /**
     * 姓名
     */
    private String xm;

    /**
     * 证件号码
     */
    private String zjhm;

    /**
     * 家庭人口数
     */
    private String jtrks;

    /**
     * 与户主关系
     */
    private String yhzgx;

    /**
     * 民族
     */
    private String mz;

    /**
     * 政治面貌
     */
    private String zzmm;

    /**
     * 文化程度
     */
    private String whcd;

    /**
     * 在校生状况
     */
    private String zxszk;

    /**
     * 健康状况
     */
    private String jkzk;

    /**
     * 劳动技能
     */
    private String ldjn;

    /**
     * 是否参加城乡居民基本医疗保险
     */
    private String sfCxJmJbYl;

    /**
     * 是否参加城镇职工基本医疗保险
     */
    private String sfCzZgJbYl;

    /**
     * 是否参加城乡居民基本养老保险
     */
    private String sfCxJmJbLao;

    /**
     * 是否参加城镇职工基本养老保险
     */
    private String sfCzZgJbLao;

    /**
     * 是否享受农村居民最低生活保障
     */
    private String sfShbz;

    /**
     * 是否参加大病保险
     */
    private String sfDbbx;

    /**
     * 是否特困供养人员
     */
    private String sfTkgy;

    /**
     * 是否易地扶贫搬迁人口
     */
    private String sfYifpbq;

    /**
     * 务工区域
     */
    private String wgqy;

    /**
     * 务工时间
     */
    private String wgsj;

    /**
     * 联系电话
     */
    private String lxdh;

    /**
     * 是否居住在大中型异地扶贫搬迁集中安置区
     */
    private String sfJzDzAn;

    /**
     * 安置区地址
     */
    private String andz;

    /**
     * 项目名称
     */
    private String xmmc;

    /**
     * 风险是否已消除
     */
    private String sfFx;

    /**
     * 风险标注次序
     */
    private String fxbzcx;

    /**
     * 风险识别时间
     */
    private String fxsbsj;

    /**
     * 风险消除时间
     */
    private String fxxcsj;

    /**
     * 风险消除方式
     */
    private String fxxcfs;

    /**
     * 致贫风险1
     */
    private String zpfx1;

    /**
     * 致贫风险2
     */
    private String zpfx2;

    /**
     * 致贫风险3
     */
    private String zpfx3;

    /**
     * 致贫风险4
     */
    private String zpfx4;

    /**
     * 致贫风险5
     */
    private String zpfx5;

    /**
     * 备注
     */
    private String bz;

    /**
     * 自然灾害类型
     */
    private String zrzhlx;

    /**
     * 信息采集人
     */
    private String xxcjr;

    /**
     * 信息采集人联系电话
     */
    private String xxcjLxdh;

    /**
     * 风险标注信息是否住房出现安全问题
     */
    private String sfFxbzZfaq;

    /**
     * 风险标注信息是否义务教育阶段适龄儿童少年失学辍学
     */
    private String sfFxbzYwjy;

    /**
     * 风险标注信息是否饮水出现安全问题
     */
    private String sfFxbzYsaq;

    /**
     * 风险标注信息是否有家庭成员未参加城乡居民（职工）基本医疗保险
     */
    private String sfFxbzWcjcx;

    /**
     * 风险消除信息是否住房出现安全问题
     */
    private String sfFxxcZfaq;

    /**
     * 风险消除信息是否义务教育阶段适龄儿童少年失学辍学
     */
    private String sfFxxcYwjy;

    /**
     * 风险消除信息是否饮水出现安全问题
     */
    private String sfFxxcYsaq;

    /**
     * 风险消除信息是否有家庭成员未参加城乡居民（职工）基本医疗保险
     */
    private String sfFxxcWcjcx;

    /**
     * 风险标注信息工资性收入
     */
    private String fxbzSrGz;

    /**
     * 风险标注信息生产经营性收入
     */
    private String fxbzSrSc;

    /**
     * 风险标注信息财产性收入
     */
    private String fxbzSrCc;

    /**
     * 风险标注信息转移性收入
     */
    private String fxbzSrZy;

    /**
     * 风险标注信息生产经营性支出
     */
    private String fxbzZcScjy;

    /**
     * 风险标注信息家庭纯收入
     */
    private String fxbzSrC;

    /**
     * 风险标注信息家庭人均纯收入
     */
    private String fxbzSrRjc;

    /**
     * 风险标注信息理赔收入
     */
    private String fxbzSrLp;

    /**
     * 风险标注信息合规自付支出
     */
    private String fxbzZcXxhg;

    /**
     * 风险标注信息纳入易返贫致贫户(监测对象)的收入参考范围
     */
    private String fxbzNrFw;

    /**
     * 风险标注信息纳入易返贫致贫户(监测对象)的人均收入参考范围
     */
    private String fxbzNrRjfw;

    /**
     * 风险消除信息工资性收入
     */
    private String fxxcSrGz;

    /**
     * 风险消除信息生产经营性收入
     */
    private String fxxcSrSc;

    /**
     * 风险消除信息财产性收入
     */
    private String fxxcSrCc;

    /**
     * 风险消除信息转移性收入
     */
    private String fxxcSrZy;

    /**
     * 风险消除信息生产经营性支出
     */
    private String fxxcZcScjy;

    /**
     * 风险消除信息家庭纯收入
     */
    private String fxxcSrC;

    /**
     * 风险消除信息家庭人均纯收入
     */
    private String fxxcSrRjc;

    /**
     * 风险消除信息理赔收入
     */
    private String fxxcSrLp;

    /**
     * 风险消除信息合规自付支出
     */
    private String fxxcZcXxhg;

    /**
     * 风险消除信息纳入易返贫致贫户(监测对象)的收入参考范围
     */
    private String fxxcNrFw;

    /**
     * 风险消除信息纳入易返贫致贫户(监测对象)的人均收入参考范围
     */
    private String fxxcNrRjfw;

    /**
     * 产业帮扶
     */
    private String cybf;

    /**
     * 就业帮扶
     */
    private String jybf;

    /**
     * 金融帮扶
     */
    private String jrbf;

    /**
     * 公益岗位帮扶
     */
    private String gygbf;

    /**
     * 住房安全保障
     */
    private String zfaqbz;

    /**
     * 饮水安全保障
     */
    private String ysaqbz;

    /**
     * 健康帮扶
     */
    private String jkbf;

    /**
     * 义务教育保障
     */
    private String ywjybz;

    /**
     * 教育帮扶
     */
    private String jaoybf;

    /**
     * 综合保障
     */
    private String zhbz;

    /**
     * 社会帮扶
     */
    private String shbf;

    /**
     * 搬迁
     */
    private String bq;

    /**
     * 生产生活条件改善
     */
    private String scshtjgz;

    /**
     * 基础设施建设
     */
    private String jcssjs;


}
