package com.huimv.farm.damsubsidy.entity.vo;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;

import java.util.Date;
import java.io.Serializable;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.huimv.farm.damsubsidy.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 落地检
 * </p>
 *
 * @author author
 * @since 2023-04-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("bill_landing_inspection")
public class BillLandingInspection extends BaseEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.ASSIGN_ID)
    private Long id;

    private String inspectionName;

    /**
     * old审核进度; 0待受理，1已拒绝，2审核中，3审核通过，4审核不通过
     *
     * 1待审核、2待隔离、3隔离中、4已完成（包括已驳回）,5驳回
     */
    private Integer inspectionSch;

    /**
     * 类型; 0落地检，
     */
    private Integer inspectionType;

    /**
     * 检疫证号
     */
    private String inspectionNum;

    /**
     * 货主
     */
    private String cargoOwner;

    /**
     * 货主手机
     */
    private String ownerPhone;

    /**
     * 0肉牛，1羊，2猪
     */
    private Integer animalType;

    /**
     * 数量及单位
     */
    private String animalNumberUp;

//    /**
//     * 数量
//     */
//    private Integer animalNumber;

    /**
     * 用途
     */
    private String useTo;

    /**
     * 启运地点
     */
    private String startTran;

    /**
     * 到达地点
     */
    private String reachTran;

    /**
     * 耳标号
     */
    private String eartags;

    /**
     * 审核人
     */
    private String reviewed;

    /**
     * 审核时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date reviewedTime;

    /**
     * 驳回理由
     */
    private String rejectReason;

    /**
     * 所属兽医站id
     */
    private Integer veterId;



}
