package com.huimv.farm.damsubsidy.service.impl;

import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.farm.damsubsidy.common.token.TokenSign;
import com.huimv.farm.damsubsidy.common.utils.Result;
import com.huimv.farm.damsubsidy.common.utils.ResultCode;
import com.huimv.farm.damsubsidy.entity.BaseAnimal;
import com.huimv.farm.damsubsidy.mapper.BaseAnimalMapper;
import com.huimv.farm.damsubsidy.service.IBaseAnimalService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 动物信息 服务实现类
 * </p>
 *
 * @author author
 * @since 2023-04-26
 */
@Service
public class BaseAnimalServiceImpl extends ServiceImpl<BaseAnimalMapper, BaseAnimal> implements IBaseAnimalService {

    @Override
    public Result noSubsidyAnimal(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String inspectionNum = paramsMap.get("inspectionNum");
        String[] inspectionNums = inspectionNum.split(",");
        List<BaseAnimal> baseAnimals = this.list(new QueryWrapper<BaseAnimal>()
                .in("inspection_num", inspectionNums).eq("is_die",0)
                .in("animal_status",1,2).eq("is_loated",0).eq("belong_to_user", TokenSign.getMemberIdByJwtToken(httpServletRequest)));
        if (ObjectUtil.isEmpty(baseAnimals)) {
            return new Result(10001,"该检疫批次中无符合要求的畜种！",false);
        }else {
            return new Result(ResultCode.SUCCESS,baseAnimals);
        }
    }
}
