package com.huimv.farm.damsubsidy.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.farm.damsubsidy.common.utils.PageUtils;
import com.huimv.farm.damsubsidy.common.utils.Result;
import com.huimv.farm.damsubsidy.common.utils.ResultCode;
import com.huimv.farm.damsubsidy.entity.BaseVeterStation;
import com.huimv.farm.damsubsidy.entity.SysUser;
import com.huimv.farm.damsubsidy.mapper.BaseVeterStationMapper;
import com.huimv.farm.damsubsidy.service.IBaseVeterStationService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author author
 * @since 2023-05-05
 */
@Service
public class BaseVeterStationServiceImpl extends ServiceImpl<BaseVeterStationMapper, BaseVeterStation> implements IBaseVeterStationService {

    @Override
    public Result page(Map map) {
        Page page = PageUtils.getPage(map);
        String name = (String)map.get("name");
        QueryWrapper<BaseVeterStation> wrapper = new QueryWrapper<BaseVeterStation>().like(StringUtils.isNotBlank(name), "station_name", name);

        return new Result(ResultCode.SUCCESS,this.page(page,wrapper));
    }
}
